﻿Imports System.Diagnostics
Imports System.Data
Imports Infragistics.Web.UI.GridControls

Partial Class _Default
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.WebHierarchicalDataGrid.DataSource = GenerateDataSource()
        Me.WebHierarchicalDataGrid.DataBind()
    End Sub

    Private Function GenerateDataSource() As DataSet
        Dim dataSource As New DataSet()
        Dim addresses As New DataTable()
        addresses.TableName = "Addresses"

        addresses.Columns.Add("Id", GetType(Integer))
        addresses.Columns.Add("Address", GetType(String))
        addresses.Columns.Add("PersonId", GetType(Integer))

        Dim row As DataRow = addresses.NewRow()
        row.SetField(Of Integer)("Id", 1)
        row.SetField(Of String)("Address", "<a href='/Default.aspx' target='_blank'>Paris</a>")
        row.SetField(Of Integer)("PersonId", 1)
        addresses.Rows.Add(row)

        row = addresses.NewRow()
        row.SetField(Of Integer)("Id", 2)
        row.SetField(Of String)("Address", "<a href='/Default.aspx' target='_blank'>Rome</a>")
        row.SetField(Of Integer)("PersonId", 1)
        addresses.Rows.Add(row)

        row = addresses.NewRow()
        row.SetField(Of Integer)("Id", 3)
        row.SetField(Of String)("Address", "<a href='/Default.aspx' target='_blank'>London</a>")
        row.SetField(Of Integer)("PersonId", 2)
        addresses.Rows.Add(row)

        row = addresses.NewRow()
        row.SetField(Of Integer)("Id", 4)
        row.SetField(Of String)("Address", "<a href='/Default.aspx' target='_blank'>LosAngeles</a>")
        row.SetField(Of Integer)("PersonId", 2)
        addresses.Rows.Add(row)

        dataSource.Tables.Add(addresses)

        Return dataSource
    End Function



    Private Sub WebHierarchicalDataGrid1_InitializeRow(sender As Object, e As Infragistics.Web.UI.GridControls.RowEventArgs) Handles WebHierarchicalDataGrid.InitializeRow
        Debug.WriteLine("InitializeRow is fired for row with id #" + e.Row.Items.Item(0).Value.ToString())
        If e.Row.Items.Count > 0 Then
            For i As Integer = 0 To e.Row.Items.Count - 1
                If e.Row.Items(i).Text.ToLower.Contains("href=") Then
                    Dim oColumn As BoundDataField = CType(e.Row.Items(i).Column, BoundDataField)
                    oColumn.HtmlEncode = False
                    oColumn.CssClass = "nowrapHTML"
                End If
            Next
        End If
    End Sub
End Class
